<template>
  <div
    data-component-group="filter-forms"
    data-component="billing"
  >
    <FiltersForm
      :has-filters="hasFilters"
      @filter="onFilter"
      @clear="onClearFilters"
    >
      <v-text-field
        v-model="search"
        type="search"
        label="Search"
        prepend-inner-icon="search"
      />

      <v-autocomplete
        v-model="business"
        :items="businesses"
        :filter="customFilter"
        :loading="isLoadingBusinesses"
        prepend-inner-icon="home"
        :return-object="true"
        item-text="name"
        label="Business"
        :menu-props="{nudgeBottom:'10'}"
        :search-input.sync="businessSearch"
      />

      <v-autocomplete
        v-model="accountingApp"
        :items="accountingApps"
        :filter="customFilter"
        prepend-inner-icon="home"
        :return-object="true"
        item-text="name"
        label="Managed by"
        :menu-props="{nudgeBottom:'10'}"
      />
    </FiltersForm>
  </div>
</template>

<script>
  import uid from 'uid';
  import colors from 'vuetify/es5/util/colors';
  import stringEscape from 'js-string-escape';
  import FiltersForm from './Filters';
  import { isNum, isStr, debounce } from '../../../utils';

  const debouncer = debounce({
    id: uid(),
    timeout: 500
  });

  // TODO: Translate component

  export default {
    components: {
      FiltersForm
    },
    data() {
      return {
        search: '',
        business: {},
        businesses: [],
        businessSearch: '',
        accountingApp: {},
        isLoadingBusinesses: false,
        colors
      };
    },
    computed: {
      activeCountry() {
        return this.$store.getters['config/country'];
      },
      hasFilters() {
        const { search, business, accountingApp } = this;

        return search !== ''
          || isNum(business.id)
          || isNum(accountingApp.id);
      },
      accountingApps() {
        return this.$store.getters['accountingApps/items'];
      }
    },
    watch: {
      businessSearch(nextSearch) {
        if (isStr(nextSearch)) {
          debouncer(() => this.getBusinesses(nextSearch));
        }
      }
    },
    methods: {
      getBusinesses(search = '') {
        const query = {
          per_page: -1,
          search,
          target_country: this.activeCountry.code
        };

        this.isLoadingBusinesses = true;
        return this.$store.dispatch('businesses/getItems', query)
          .then(({ items }) => {
            this.businesses = items;
            this.isLoadingBusinesses = false;
            return items;
          })
          .catch((err) => {
            this.isLoadingBusinesses = false;
            return err;
          });
      },
      onFilter() {
        const { search, business, accountingApp } = this;
        const formattedSearch = stringEscape(search);

        this.$emit('filter', {
          search: formattedSearch,
          business,
          accountingApp
        });
      },
      onClearFilters() {
        this.search = '';
        this.business = {};
        this.accountingApp = {};

        this.$emit('clearFilters');
      },
      customFilter(item, queryText) {
        const textOne = item.name.toLowerCase();
        const searchText = queryText.toLowerCase();

        return textOne.indexOf(searchText) > -1;
      }
    }
  };
</script>

<style lang="stylus" scoped>
  [data-component-group="filter-forms"] {
    &[data-component="billing"] {
      h1 {
        display: flex;
        align-items: center;
        margin: 0 0 32px 0;
        min-height: 48px;
      }
    }
  }
</style>
